
#include <dxconfig.h>
#include <dx/dx.h>
#include "gl2ps.h"


/*
 * Error _dxfAsyncRender (Object, Camera, char *, char *);
 * Error _dxfAsyncDelete (char *);
 * Error DXSetSoftwareWindowActive(char *, int);
 */

#define MAX_PARAMS 21

Error m_PsVectorPrint(Object *in, Object *out)
{
	char *filename;
	char *where;
	FILE *fp;
	int state = GL2PS_OVERFLOW, buffsize = 0;
	GLint viewport[4];
	int format, sort, options, nbcol;
	
	ModuleInput	minput[MAX_PARAMS];
	ModuleOutput moutput[MAX_PARAMS];
	
	format = GL2PS_EPS;
//	sort = GL2PS_SIMPLE_SORT;
	sort = GL2PS_BSP_SORT;
//	sort = GL2PS_NO_SORT;
//	options = GL2PS_SILENT | GL2PS_OCCLUSION_CULL | GL2PS_NO_PS3_SHADING;
	options = GL2PS_SILENT | GL2PS_NO_PS3_SHADING;
//	options = GL2PS_NONE;
	nbcol = 0;
	viewport[0] = 0;
	viewport[1] = 0;
	viewport[2] = 0;
	viewport[3] = 0;
	
	/*
	* Initialize all outputs to NULL
	*/
	
	if (!in[0]) {
	DXSetError(ERROR_BAD_PARAMETER, "missing object input");
	goto error;
	}
	if (!in[1]) {
	DXSetError(ERROR_BAD_PARAMETER, "missing camera input");
	goto error;
	}
	if (!in[2]) {
	DXSetError(ERROR_BAD_PARAMETER, "missing where input");
	goto error;
	}
	
	
	/* check filename 
	 */
	if (!in[3]) {
		DXSetError(ERROR_BAD_PARAMETER, "#10000", "file name");
		return ERROR;
	}

	/* unless multifile is enabled, the filename is required to be
	 *	a single a string.
	 */
	if (!DXExtractString(in[3], &filename))
	{
		DXSetError(ERROR_BAD_PARAMETER, "#10200", "file name");
		return ERROR;
	}
	fp = fopen(filename, "w");
	if(!fp){
		DXSetError(ERROR_DATA_INVALID, "Cennot open file", filename);
		return ERROR;
	}
	/* set hardware rendering */
	DXSetStringAttribute(in[0], "rendering mode", "hardware");

	DXModSetObjectInput(&minput[0], "object", in[0]);
	DXModSetObjectInput(&minput[1], "camera", in[1]);
	DXModSetObjectInput(&minput[2], "where", in[2]);

	DXCallModule("Display",3,minput, 0, moutput);
	glGetIntegerv(GL_VIEWPORT, viewport);
	DXExtractString(in[2],&where);
	DXMessage("0 %s xx\n",where);
	while(state == GL2PS_OVERFLOW){
		buffsize += 1024*1024;
		DXMessage("1 %s xx\n",where);
		gl2psBeginPage(filename, "test", viewport, format, sort, 
					options,
					GL_RGBA, 0, NULL, nbcol, nbcol, nbcol, 
					buffsize, fp, filename);
		DXMessage("2 %s xx\n",where);
		DXCallModule("Display", 3, minput, 0, moutput);
		DXMessage("3 %s xx\n",where);
		state = gl2psEndPage();
		DXMessage("4\n");
	}

	/* 
	* successful return 
	*/
	done:
	if ( fp ) fclose(fp);
	return OK;
	
	/* 
	* return on error 
	*/	

 error:
	/*
	* On error, any successfully-created outputs are deleted.
	*/
	if ( fp ) fclose(fp);
	return ERROR;
}




